<template>
  <!-- The Modal -->
  <div class="modal" v-if="isModalShowing">
    <!-- Modal content -->
    <div class="modal-content">
      <div>
        <span class='close-btn' @click="closeModalClick">&times;</span>
      </div>
      <slot></slot>
    </div>
  </div>
</template>

<script setup>
import { defineProps, ref, defineEmits } from 'vue';

defineProps({
  showModalButtonText: {
    type: String,
    default: 'Show modal'
  }
})

const emit = defineEmits(['closeModal'])

const isModalShowing = ref(true)


const closeModalClick = () => {
  emit('closeModal')
  isModalShowing.value = false
}
</script>

<style scoped>
/* Source: https://www.w3schools.com/howto/howto_css_modals.asp
 * The Modal (background)
 */
.modal {
  display: block; /* Hidden by default */
  position: fixed; /* Stay in place */
  z-index: 1; /* Sit on top */
  left: 0;
  top: 0;
  width: 100%; /* Full width */
  height: 100%; /* Full height */
  overflow: auto; /* Enable scroll if needed */
  background-color: rgb(0,0,0); /* Fallback color */
  background-color: rgba(0,0,0,0.4); /* Black w/ opacity */
}

/* Modal Content/Box */
.modal-content {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background-color: #fefefe;
  padding: 20px;
  padding-top: 60px;
  border: 1px solid #888;
}

/* The Close Button */
.close-btn {
  cursor: pointer;
  position: absolute;
  top: 20px;
  right: 20px;
  color: #aaa;
  font-size: 28px;
  font-weight: bold;
}

.close:hover,
.close:focus {
  color: black;
  text-decoration: none;
  cursor: pointer;
}
</style>